import { Component, OnInit } from '@angular/core';
import { ModalController } from '@ionic/angular';
import { FormGroup, FormBuilder, Validators } from '@angular/forms';

@Component({
    selector: 'app-form',
    templateUrl: './form.component.html',
    styleUrls: ['./form.component.scss'],
})
export class FormComponent implements OnInit {
    /**
     * @var bool flag indicating if form was submitted
     */
    isSubmitted = false;
    /**
     * @var FormGroup form object generated by Angular
     */
    formObj: FormGroup;

    constructor(private modalController: ModalController, private formBuilder: FormBuilder) { }
    /**
     * Build form with Angular
     */
    ngOnInit() {
        this.formObj = this.formBuilder.group(
            {
                "host": ["", [Validators.required]],
                "login": ["", [Validators.required]]
            }, {}
        );
    }
    /**
     * Manage form submition
     * 
     * @param values submitted form data
     */
    save(values: any): void {
        this.isSubmitted = true;
        // @NOTE if errors occurred then stop and display them
        if (this.formObj.invalid) {
            return;
        }

        this.dismissModal(values);
    }
    /**
     * Getter for simplifying controls access
     */
    get frmCtrl() { return this.formObj.controls; }
    /**
     * Close modal containing form and send form data to parent page
     */
    dismissModal(formData: Object | null) {
        this.modalController.dismiss(formData);
    }

}
